#!/usr/bin/awk
#### ե᡼ץ recvmail.awk V2.11 
#### Copyright 1998,1999,2000 GORRY. 
#### mailto: gorry@hauN.org 
#### 
#### ƥȺѥåȤFreeBSDΤߡ
#### 
#### History: 
#### 2000/09/20 V2.11 ᡼sjis¸ʤХ
#### 2000/07/05 V2.10 config.awkѤ˽
#### 2000/01/12 V2.01 GETDIRб
#### 1999/09/30 V2.00 ˥塼롣 
#### 1999/09/29 V1.16 ѥɥå˰ư 
#### 1999/08/24 V1.14 PUTDIRꤷ˺Х
#### 1999/01/29 V1.10 եࡣ 
#### 1999/01/04 V1.06 ǯեʤbugfix 
#### 1998/12/17 V1.04  

BEGIN {
	ok1 = 0;
	ok2 = 0;
	while ( (getline line) > 0 ) {
		print line;
		if ( length( line ) == 0 ) {
			print "--- Reject this mail.\n";
			exit;
		}
		if ( match( line, "Subject:.*" MAILSUBJECT ) ) {
			print "--- Accept mail Subject.\n";
			ok1 = 1;
		}
		if ( match( line, "From:.*" MAILFROM ) ) {
			print "--- Accept mail From.\n";
			ok2 = 1;
		}
		if ( ok1 && ok2 ) {
			print "--- Accept this mail.\n";
			break;
		}
	}

	ok = 0;
	while ( (getline line) > 0 ) {
		print line;
		if ( length( line ) == 0 ) {
			ok = 1;
			break;
		}
	}
	if ( ok == 0 ) {
		print "--- Mail syntax error.\n";
		exit;
	}
	print "--- Mail header end.\n";

	ok = 0;
	while ( (getline line) > 0 ) {
#		print line;
		if ( length( line ) == 0 ) {
			continue;
		}
		split( line, l );
		if ( l[1] = "01" ) {
			ok = 1;
			year = l[2];
			month = l[3];
			date = l[4];
			pass = l[5];
			gsub( /[^-_0-9A-Za-z]/, "", pass );
			print "--- Read information\n";
			break;
		}
	}
	if ( ok == 0 ) {
		print "--- Mail syntax error.\n";
		exit;
	}

	ok = 0;
	while ( (getline line) > 0 ) {
#		print line;
		if ( length( line ) == 0 ) {
			ok = 1;
			break;
		}
	}
	if ( ok == 0 ) {
		print "--- Mail syntax error.\n";
		exit;
	}
	print "--- Diary information end.\n";

	if ( pass == "" ) {
		print "--- No password.\n";
		exit;
	}

	perlcmd = PERLCMD " mkcrypt.pl " pass;
	passwd = KEEPDIR SLASH "upload.pass";
#	print perlcmd;
	if ( (perlcmd|getline pass1) < 0 ) {
#		print "pass1";
		exit;
	}
	close( perlcmd );
#	print pass1;
	if ( (getline pass2<passwd) < 0 ) {
#		print "pass2";
		exit;
	}
	close( passwd );
#	print pass2;
	if ( pass1 != pass2 ) {
		print "--- Password NG.\n";
		exit;
	}
	print "--- Password OK.\n";

	if ( (month==99) && (date==99) ) {
		diary = sprintf( KEEPDIR SLASH "%02d.html", year );
	} else {
		dir = sprintf( GETDIR SLASH "%04d", year );
		cmd = sprintf( "if [ -e " dir " ] ; then else mkdir " dir " ; fi" );
#		print cmd;
		system( cmd );
		cmd = sprintf( CHMODCMD " " CHMODOPT " " dir );
		system( cmd );
		diary = sprintf( GETDIR SLASH "%04d" SLASH "%02d%02d.html", year, month, date );
	}

	cmd = NKFCMD " -s >" diary; # sjis
	while ( (getline line) > 0 ) {
		print line | cmd;
	}
	close( cmd );
	close( diary );
	cmd = sprintf( CHMODCMD " " CHMODOPT " " diary );
	system( cmd );

	cmd = AWKCMD " -f config.awk -f mkd.awk " year " " month " " date;
	system( cmd );
	print "--- Finished.\n";
#	print cmd;
}

# [EOF]
